/*
Copyright 2018 Ultimaker

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Ultimaker/gcp-operator/pkg/apis/gcp/v1alpha1"
	scheme "github.com/Ultimaker/gcp-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// GCPCloudSQLInstancesGetter has a method to return a GCPCloudSQLInstanceInterface.
// A group's client should implement this interface.
type GCPCloudSQLInstancesGetter interface {
	GCPCloudSQLInstances(namespace string) GCPCloudSQLInstanceInterface
}

// GCPCloudSQLInstanceInterface has methods to work with GCPCloudSQLInstance resources.
type GCPCloudSQLInstanceInterface interface {
	Create(*v1alpha1.GCPCloudSQLInstance) (*v1alpha1.GCPCloudSQLInstance, error)
	Update(*v1alpha1.GCPCloudSQLInstance) (*v1alpha1.GCPCloudSQLInstance, error)
	UpdateStatus(*v1alpha1.GCPCloudSQLInstance) (*v1alpha1.GCPCloudSQLInstance, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.GCPCloudSQLInstance, error)
	List(opts v1.ListOptions) (*v1alpha1.GCPCloudSQLInstanceList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GCPCloudSQLInstance, err error)
	GCPCloudSQLInstanceExpansion
}

// gCPCloudSQLInstances implements GCPCloudSQLInstanceInterface
type gCPCloudSQLInstances struct {
	client rest.Interface
	ns     string
}

// newGCPCloudSQLInstances returns a GCPCloudSQLInstances
func newGCPCloudSQLInstances(c *GcpV1alpha1Client, namespace string) *gCPCloudSQLInstances {
	return &gCPCloudSQLInstances{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the gCPCloudSQLInstance, and returns the corresponding gCPCloudSQLInstance object, and an error if there is any.
func (c *gCPCloudSQLInstances) Get(name string, options v1.GetOptions) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	result = &v1alpha1.GCPCloudSQLInstance{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of GCPCloudSQLInstances that match those selectors.
func (c *gCPCloudSQLInstances) List(opts v1.ListOptions) (result *v1alpha1.GCPCloudSQLInstanceList, err error) {
	result = &v1alpha1.GCPCloudSQLInstanceList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested gCPCloudSQLInstances.
func (c *gCPCloudSQLInstances) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a gCPCloudSQLInstance and creates it.  Returns the server's representation of the gCPCloudSQLInstance, and an error, if there is any.
func (c *gCPCloudSQLInstances) Create(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	result = &v1alpha1.GCPCloudSQLInstance{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		Body(gCPCloudSQLInstance).
		Do().
		Into(result)
	return
}

// Update takes the representation of a gCPCloudSQLInstance and updates it. Returns the server's representation of the gCPCloudSQLInstance, and an error, if there is any.
func (c *gCPCloudSQLInstances) Update(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	result = &v1alpha1.GCPCloudSQLInstance{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		Name(gCPCloudSQLInstance.Name).
		Body(gCPCloudSQLInstance).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *gCPCloudSQLInstances) UpdateStatus(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	result = &v1alpha1.GCPCloudSQLInstance{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		Name(gCPCloudSQLInstance.Name).
		SubResource("status").
		Body(gCPCloudSQLInstance).
		Do().
		Into(result)
	return
}

// Delete takes name of the gCPCloudSQLInstance and deletes it. Returns an error if one occurs.
func (c *gCPCloudSQLInstances) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *gCPCloudSQLInstances) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched gCPCloudSQLInstance.
func (c *gCPCloudSQLInstances) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	result = &v1alpha1.GCPCloudSQLInstance{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("gcpcloudsqlinstances").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
